﻿using LottoPicker.Utility;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LottoPicker.Dialog
{
    public partial class HistoryDialog : Form
    {
        public HistoryDialog()
        {
            InitializeComponent();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            int start = int.Parse(txtStartNum.Text);
            int end = int.Parse(txtEndNum.Text);
            if (start > end)
            {
                int tmp = start;
                start = end;
                end = tmp;
            }

            List<int> history = new List<int>(6 * (end - start + 1));
            for (int i = start; i <= end; i++)
            {
                history.AddRange(GetHistory(i));
            }

            history.Sort();
            Dictionary<string, int> historyCount = new Dictionary<string, int>();
            for (int i = 0; i < history.Count; i++)
            {
                string key = history[i].ToString();
                if (!historyCount.ContainsKey(key))
                    historyCount.Add(key, 0);

                historyCount[key]++;
            }

            PrintHistory(historyCount);
        }

        private List<int> GetHistory(int round)
        {
            List<int> result = new List<int>(6);
            string url = $"http://www.dhlottery.co.kr/common.do?method=getLottoNumber&drwNo={round.ToString()}";
            JObject response = WebAPIUtil.CallRequest(url);
            result.Add(int.Parse(response["drwtNo1"].ToString()));
            result.Add(int.Parse(response["drwtNo2"].ToString()));
            result.Add(int.Parse(response["drwtNo3"].ToString()));
            result.Add(int.Parse(response["drwtNo4"].ToString()));
            result.Add(int.Parse(response["drwtNo5"].ToString()));
            result.Add(int.Parse(response["drwtNo6"].ToString()));

            return result;
        }

        private void PrintHistory(Dictionary<string, int> history)
        {
            txtResult.Clear();
            StringBuilder stringBuilder = new StringBuilder();
            foreach (KeyValuePair<string, int> pair in history)
            {
                string append = $"[{pair.Key}공] → {pair.Value}회";
                stringBuilder.AppendLine(append);
            }

            txtResult.AppendText(stringBuilder.ToString());
        }
    }
}
